/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageContactOrg type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageContactOrg{}

// MessageContactOrg struct for MessageContactOrg
type MessageContactOrg struct {
	Company *string `json:"company,omitempty"`
	Department *string `json:"department,omitempty"`
	Title *string `json:"title,omitempty"`
}

// NewMessageContactOrg instantiates a new MessageContactOrg object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageContactOrg() *MessageContactOrg {
	this := MessageContactOrg{}
	return &this
}

// NewMessageContactOrgWithDefaults instantiates a new MessageContactOrg object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageContactOrgWithDefaults() *MessageContactOrg {
	this := MessageContactOrg{}
	return &this
}

// GetCompany returns the Company field value if set, zero value otherwise.
func (o *MessageContactOrg) GetCompany() string {
	if o == nil || IsNil(o.Company) {
		var ret string
		return ret
	}
	return *o.Company
}

// GetCompanyOk returns a tuple with the Company field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactOrg) GetCompanyOk() (*string, bool) {
	if o == nil || IsNil(o.Company) {
		return nil, false
	}
	return o.Company, true
}

// HasCompany returns a boolean if a field has been set.
func (o *MessageContactOrg) HasCompany() bool {
	if o != nil && !IsNil(o.Company) {
		return true
	}

	return false
}

// SetCompany gets a reference to the given string and assigns it to the Company field.
func (o *MessageContactOrg) SetCompany(v string) {
	o.Company = &v
}

// GetDepartment returns the Department field value if set, zero value otherwise.
func (o *MessageContactOrg) GetDepartment() string {
	if o == nil || IsNil(o.Department) {
		var ret string
		return ret
	}
	return *o.Department
}

// GetDepartmentOk returns a tuple with the Department field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactOrg) GetDepartmentOk() (*string, bool) {
	if o == nil || IsNil(o.Department) {
		return nil, false
	}
	return o.Department, true
}

// HasDepartment returns a boolean if a field has been set.
func (o *MessageContactOrg) HasDepartment() bool {
	if o != nil && !IsNil(o.Department) {
		return true
	}

	return false
}

// SetDepartment gets a reference to the given string and assigns it to the Department field.
func (o *MessageContactOrg) SetDepartment(v string) {
	o.Department = &v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *MessageContactOrg) GetTitle() string {
	if o == nil || IsNil(o.Title) {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactOrg) GetTitleOk() (*string, bool) {
	if o == nil || IsNil(o.Title) {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *MessageContactOrg) HasTitle() bool {
	if o != nil && !IsNil(o.Title) {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *MessageContactOrg) SetTitle(v string) {
	o.Title = &v
}

func (o MessageContactOrg) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageContactOrg) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Company) {
		toSerialize["company"] = o.Company
	}
	if !IsNil(o.Department) {
		toSerialize["department"] = o.Department
	}
	if !IsNil(o.Title) {
		toSerialize["title"] = o.Title
	}
	return toSerialize, nil
}

type NullableMessageContactOrg struct {
	value *MessageContactOrg
	isSet bool
}

func (v NullableMessageContactOrg) Get() *MessageContactOrg {
	return v.value
}

func (v *NullableMessageContactOrg) Set(val *MessageContactOrg) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageContactOrg) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageContactOrg) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageContactOrg(val *MessageContactOrg) *NullableMessageContactOrg {
	return &NullableMessageContactOrg{value: val, isSet: true}
}

func (v NullableMessageContactOrg) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageContactOrg) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


